/*
 *  CHANGER, {akii-root}/src/changer.c
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#include <errno.h>
#include "changer.h"
#include "interpreter.h"
#include "variables.h"
#include "main.h"
#include "screen.h"
#include "terms.h"

struct valtozo *akii_verzio;

void c_timeout(struct valtozo *var)
{
    int i;
    char *s;

    i = strtol(var->ertek, &s, 10);
    if ((*s) || (i < 10) || (i > 1790)) {
	if (*s)
	    setivar(var, i = 1000);
	else if (i < 10)
	    setivar(var, i = 10);
	else
	    setivar(var, i = 1790);
	return;
    }
    timeout = i;
    return;
}
void c_floodprotect(struct valtozo *var)
{
    int i;
    char *s;

    i = strtol(var->ertek, &s, 10);
    if ((*s) || (i < 0) || (i > 5000)) {
	if (*s)
	    setivar(var, i = 1000);
	else if (i < 0)
	    setivar(var, i = 0);
	else
	    setivar(var, i = 5000);
	return;
    }
    floodprotect = i;
    return;
}
void c_winsize(struct valtozo *var)
{
    int i;
    char *s;

    i = strtol(var->ertek, &s, 10);
    if ((*s) || (i < 0) || (i > LINES - 5)) {
	if (*s)
	    setivar(var, i = 10);
	else if (i <= 0) {
	    setivar(var, i = 0);
	}
	else {
	    if (i > LINES - 5)
		wantedwinsize = i;
	    setivar(var, i = LINES - 5);
	}
	return;
    }
    else
	wantedwinsize = i;
    winsize = i;
    if (winsize)
	oldwinsize = winsize;
    if (topline && winsize) {
	i = (topline - 1) % winsize;
	topline -= i;
	if (topline <= 0)
	    topline = 1;
    }
    refresh(0);
    return;
}
void c_novice(struct valtozo *var)
{
    int i;
    char *s;

    i = strtol(var->ertek, &s, 10);
    if (*s) {
	setvar(var, "1");
	return;
    }
    novice = i;
    return;
}
void c_usebold(struct valtozo *var)
{
    int i;
    char *s;

    i = strtol(var->ertek, &s, 10);
    if (*s) {
	setvar(var, "1");
	return;
    }
    usebold = i;
    return;
}
void c_usewin(struct valtozo *var)
{
    int i;
    char *s;

    i = strtol(var->ertek, &s, 10);
    if (*s) {
	setvar(var, "1");
	return;
    }
    usewin = i;
    return;
}
void c_nocs(struct valtozo *var)
{
    int i;
    char *s;

    i = strtol(var->ertek, &s, 10);
    if (*s) {
	setvar(var, "1");
	return;
    }
    nocs = i;
    return;
}
void c_sortby(struct valtozo *var)
{
    int i;
    char *s;

    if (!var->ertek[0]) {
	setvar(var, "Nick");
	return;
    }
    var->ertek[0] = toupper(var->ertek[0]);
    switch (var->ertek[0]) {
	case 'N':
	case 'C':
	case 'F':
	case 'S':
	    break;
	default:
	    setvar(var, "Nick");
	    return;
    }
    sortby = var->ertek[0];
    return;
}
void checkchanges(struct valtozo *var)
{
    if (var == akii_timeout)
	c_timeout(var);
    else if (var == akii_novice)
	c_novice(var);
    else if (var == akii_usebold)
	c_usebold(var);
    else if (var == akii_nocs)
	c_nocs(var);
    else if (var == akii_sortby)
	c_sortby(var);
    else if (var == akii_winsize)
	c_winsize(var);
    else if (var == akii_usewin)
	c_usewin(var);
    else if (var == akii_floodprotect)
	c_floodprotect(var);
    if (errno == EINVAL)
	errno = 0;
    return;
}
