/*
 *  SCREEN, {akii-root}/src/screen.h
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#ifndef _SCREEN_H_
#define _SCREEN_H_ 1
#include "variables.h"

struct inplines {
    char *s;
    struct inplines *prev, *next;
};

extern int cursor, curcur;
extern char curinp[1200];
extern struct inplines *inps, *ainp;
extern int inpnum;
extern int gorg;

extern char saveinp[1024];
extern int savecursor;

extern struct inplines *sorok, *soreleje;
extern struct inplines *scrollsorok;
extern int sorokszam;
extern char inp[1024], *inpp;
extern int inplen;
extern int botmode;

extern struct valtozo *akii_usebold;
extern struct valtozo *akii_nick;
extern struct valtozo *akii_csatorna;
extern struct valtozo *akii_nocs;
extern int usebold, nocs;
extern int winsize, usewin, oldwinsize, wantedwinsize;

void initscreen(void);
void donescreen(void);
void refresh(int);
void writestatus(void);
void writeinput(void);
void writesorok(int);

int echostr(char *);
void freeinplines(void);

void resizewindow(int);
void writewindow(void);
void writewindowstatus(void);

extern int topline, lastwinline;
extern char winbase[300];
extern char winbase_temp[300];
extern char *winlines[2000];
void winclear(void);
void winecho(char *);
void winfress(int, char *);

#endif
